diff -Naur openssl-1.0.0q.orig/crypto/x509/x509_vfy.c openssl-1.0.0q/crypto/x509/x509_vfy.c
--- openssl-1.0.0q.orig/crypto/x509/x509_vfy.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509_vfy.c	2017-04-25 16:23:40.712621573 +0200
@@ -56,11 +56,13 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <time.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include <openssl/crypto.h>
 #include <openssl/lhash.h>
 #include <openssl/buffer.h>
@@ -116,7 +118,9 @@
 static int check_trust(X509_STORE_CTX *ctx);
 static int check_revocation(X509_STORE_CTX *ctx);
 static int check_cert(X509_STORE_CTX *ctx);
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
 static int check_policy(X509_STORE_CTX *ctx);
+#endif
 
 static int get_crl_score(X509_STORE_CTX *ctx, X509 **pissuer,
 			unsigned int *preasons,
@@ -135,7 +139,9 @@
 			STACK_OF(X509) *crl_path);
 
 static int internal_verify(X509_STORE_CTX *ctx);
-const char X509_version[]="X.509" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char X509_version[]="X.509" OPENSSL_VERSION_PTEXT; /* ARRAY OK 2008-02-27 haavardm */
+#endif
 
 
 static int null_callback(int ok, X509_STORE_CTX *e)
@@ -155,6 +161,9 @@
 	X509 *x,*xtmp,*chain_ss=NULL;
 	int bad_chain = 0;
 	X509_VERIFY_PARAM *param = ctx->param;
+ #ifdef _DEBUG
+  	X509_NAME *xn;
+ #endif
 	int depth,i,ok=0;
 	int num;
 	int (*cb)(int xok,X509_STORE_CTX *xctx);
@@ -204,12 +213,42 @@
 		                         */
 
 		/* If we are self signed, we break */
+#ifdef _DEBUG
+		xn=X509_get_issuer_name(x);
+#endif
 		if (ctx->check_issued(ctx, x,x)) break;
 
 		/* If we were passed a cert chain, use it first */
 		if (ctx->untrusted != NULL)
 			{
-			xtmp=find_issuer(ctx, sktmp,x);
+ 			/** Opera new code: check in reporsitory first, even if we have the chain */
+ 			xtmp = NULL;
+ 
+ 			ok = ctx->get_issuer(&xtmp, ctx, x);
+ 
+ 			if (ok > 0 && xtmp != NULL)
+ 			{
+ 				if(X509_cmp_time(X509_get_notAfter(xtmp), NULL) <=0)
+ 				{
+ 					//Expired, use server provided cert or wait for the completion
+ 					X509_free(xtmp);
+ 					xtmp = NULL;
+ 					//Fall through
+ 				}
+ 				else if(ctx->check_issued(ctx, xtmp,xtmp))
+ 				{
+ 					X509_free(xtmp);
+ 					// If we find a root, terminate search for CAs; the chain will be completed further down.
+ 					break;
+ 				}
+ 			}
+ 			if(ok < 0)
+ 				goto end;
+ 
+ 			X509 *xtmp2 = NULL;
+ 			if(xtmp == NULL)
+ 				xtmp2 = xtmp = find_issuer(ctx, sktmp,x);
+ 
 			if (xtmp != NULL)
 				{
 				if (!sk_X509_push(ctx->chain,xtmp))
@@ -217,7 +256,8 @@
 					X509err(X509_F_X509_VERIFY_CERT,ERR_R_MALLOC_FAILURE);
 					goto end;
 					}
-				CRYPTO_add(&xtmp->references,1,CRYPTO_LOCK_X509);
+				if(xtmp2)
+					CRYPTO_add(&xtmp->references,1,CRYPTO_LOCK_X509);
 				(void)sk_X509_delete_ptr(sktmp,xtmp);
 				ctx->last_untrusted++;
 				x=xtmp;
@@ -240,6 +280,9 @@
 
 	i=sk_X509_num(ctx->chain);
 	x=sk_X509_value(ctx->chain,i-1);
+#ifdef _DEBUG
+	xn = X509_get_subject_name(x);
+#endif
 	if (ctx->check_issued(ctx, x, x))
 		{
 		/* we have a self signed certificate */
@@ -288,11 +331,18 @@
 		if (depth < num) break;
 
 		/* If we are self signed, we break */
+#ifdef _DEBUG
+		xn=X509_get_issuer_name(x);
+#endif
 		if (ctx->check_issued(ctx,x,x)) break;
 
 		ok = ctx->get_issuer(&xtmp, ctx, x);
 
-		if (ok < 0) return ok;
+		if (ok < 0)
+		{
+			if (sktmp != NULL) sk_X509_free(sktmp);
+			return ok;
+		}
 		if (ok == 0) break;
 
 		x = xtmp;
@@ -300,12 +350,18 @@
 			{
 			X509_free(xtmp);
 			X509err(X509_F_X509_VERIFY_CERT,ERR_R_MALLOC_FAILURE);
+			if (sktmp != NULL) sk_X509_free(sktmp);
 			return 0;
 			}
 		num++;
 		}
 
 	/* we now have our chain, lets check it... */
+#ifdef _DEBUG
+  	xn=X509_get_issuer_name(x);
+	/* Supress warning "variable set but not use" */
+	(void) xn;
+#endif
 
 	/* Is last certificate looked up self signed? */
 	if (!ctx->check_issued(ctx,x,x))
@@ -377,10 +433,17 @@
 	if (!ok) goto end;
 #endif
 
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
 	/* If we get this far evaluate policies */
 	if (!bad_chain && (ctx->param->flags & X509_V_FLAG_POLICY_CHECK))
 		ok = ctx->check_policy(ctx);
 	if(!ok) goto end;
+#else
+	// Suppress warning variable ‘bad_chain’ set but not used
+	(void)bad_chain;
+#endif
+
+
 	if (0)
 		{
 end:
@@ -394,9 +457,76 @@
 
 /* Given a STACK_OF(X509) find the issuer of cert (if any)
  */
+extern int CheckX509_EV_dataID();
 
 static X509 *find_issuer(X509_STORE_CTX *ctx, STACK_OF(X509) *sk, X509 *x)
 {
+#ifdef SSL_CHECK_EXT_VALIDATION_POLICY
+	// Opera added code that will attempt to find a preferred root linking directly to this certificate
+	int i;
+	BOOL tested= FALSE;
+	BOOL cand_have_root = FALSE;
+	BOOL cand_have_policies = FALSE;
+	X509 *issuer_cand= NULL, *issuer;
+	for (i = 0; i < sk_X509_num(sk); i++)
+	{
+		issuer = sk_X509_value(sk, i);
+		if (ctx->check_issued(ctx, x, issuer))
+		{
+			if(issuer_cand)
+			{
+				if(!tested)
+				{
+					X509 *tmp1 = NULL;
+					ctx->get_issuer(&tmp1, ctx, issuer_cand);
+					if(tmp1)
+					{
+						if(ctx->check_issued(ctx, tmp1, tmp1))
+						{
+							cand_have_root = TRUE;
+							cand_have_policies = ((STACK_OF(ASN1_OBJECT) *)X509_get_ex_data(tmp1, CheckX509_EV_dataID()) != NULL ? TRUE : FALSE);
+							if(cand_have_policies)
+							{
+								X509_free(tmp1);
+								break; // policies exist, we will use this one.
+							}
+						}
+					}
+
+					X509_free(tmp1);
+					tested = TRUE;
+				}
+				X509 *tmp2 = NULL;
+				ctx->get_issuer(&tmp2, ctx, issuer);
+				if(tmp2)
+				{
+					// Only embedded roots are considered
+					if(ctx->check_issued(ctx, tmp2, tmp2))
+					{
+						BOOL have_policies = ((STACK_OF(ASN1_OBJECT) *)X509_get_ex_data(tmp2, CheckX509_EV_dataID()) != NULL ? TRUE : FALSE);
+
+						if(!cand_have_root || (!cand_have_policies && have_policies))
+						{
+							issuer_cand = issuer;
+							cand_have_root = TRUE;
+							cand_have_policies = have_policies;
+
+							if(cand_have_policies)
+							{
+								X509_free(tmp2);
+								break; // policies exist, we will use this one.
+							}
+						}
+					}
+					X509_free(tmp2);
+				}
+			}
+			else
+				issuer_cand = issuer;
+		}
+	}
+	return issuer_cand;
+#else
 	int i;
 	X509 *issuer;
 	for (i = 0; i < sk_X509_num(sk); i++)
@@ -406,6 +536,7 @@
 			return issuer;
 		}
 	return NULL;
+#endif
 }
 
 /* Given a possible certificate and issuer check them */
@@ -424,9 +555,9 @@
 	ctx->current_cert = x;
 	ctx->current_issuer = issuer;
 	return ctx->verify_cb(0, ctx);
-	return 0;
 }
 
+#ifndef OPERA_SMALL_VERSION
 /* Alternative lookup method: look from a STACK stored in other_ctx */
 
 static int get_issuer_sk(X509 **issuer, X509_STORE_CTX *ctx, X509 *x)
@@ -440,7 +571,8 @@
 	else
 		return 0;
 }
-	
+#endif // !OPERA_SMALL_VERSION
+
 
 /* Check a certificate chains extensions for consistency
  * with the supplied purpose
@@ -479,10 +611,12 @@
 		{
 		allow_proxy_certs =
 			!!(ctx->param->flags & X509_V_FLAG_ALLOW_PROXY_CERTS);
+#ifndef OPERA_SMALL_VERSION
 		/* A hack to keep people who don't want to modify their
 		   software happy */
 		if (getenv("OPENSSL_ALLOW_PROXY_CERTS"))
 			allow_proxy_certs = 1;
+#endif // !OPERA_SMALL_VERSION
 		purpose = ctx->param->purpose;
 		}
 
@@ -695,6 +829,10 @@
 	X509 *x;
 	int ok, cnum;
 	unsigned int last_reasons;
+
+	/* Suppress warning "potentially uninitialized local variable used". */
+	ok = 0;
+
 	cnum = ctx->error_depth;
 	x = sk_X509_value(ctx->chain, cnum);
 	ctx->current_cert = x;
@@ -1486,6 +1624,7 @@
 	return 1;
 	}
 
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
 static int check_policy(X509_STORE_CTX *ctx)
 	{
 	int ret;
@@ -1535,6 +1674,7 @@
 
 	return 1;
 	}
+#endif
 
 static int check_cert_time(X509_STORE_CTX *ctx, X509 *x)
 	{
@@ -1692,14 +1832,14 @@
 	if (ctm->type == V_ASN1_UTCTIME)
 		{
 		if ((i < 11) || (i > 17)) return 0;
-		memcpy(p,str,10);
+		op_memcpy(p,str,10);
 		p+=10;
 		str+=10;
 		}
 	else
 		{
 		if (i < 13) return 0;
-		memcpy(p,str,12);
+		op_memcpy(p,str,12);
 		p+=12;
 		str+=12;
 		}
@@ -1750,7 +1890,7 @@
 		if (i < j) return -1;
 		if (i > j) return 1;
 		}
-	i=strcmp(buff1,buff2);
+	i=op_strcmp(buff1,buff2);
 	if (i == 0) /* wait a second then return younger :-) */
 		return -1;
 	else
@@ -1773,7 +1913,7 @@
 	time_t t;
 
 	if (in_tm) t = *in_tm;
-	else time(&t);
+	else op_time(&t);
 
 	if (s && !(s->flags & ASN1_STRING_FLAG_MSTRING))
 		{
@@ -1828,6 +1968,7 @@
 	return 1;
 	}
 
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 int X509_STORE_CTX_get_ex_new_index(long argl, void *argp, CRYPTO_EX_new *new_func,
 	     CRYPTO_EX_dup *dup_func, CRYPTO_EX_free *free_func)
 	{
@@ -1836,6 +1977,7 @@
 	return CRYPTO_get_ex_new_index(CRYPTO_EX_INDEX_X509_STORE_CTX, argl, argp,
 			new_func, dup_func, free_func);
 	}
+#endif
 
 int X509_STORE_CTX_set_ex_data(X509_STORE_CTX *ctx, int idx, void *data)
 	{
@@ -1872,6 +2014,7 @@
 	return ctx->chain;
 	}
 
+#if !defined OPERA_SMALL_VERSION || !defined OPENSSL_NO_OCSP
 STACK_OF(X509) *X509_STORE_CTX_get1_chain(X509_STORE_CTX *ctx)
 	{
 	int i;
@@ -1885,6 +2028,7 @@
 		}
 	return chain;
 	}
+#endif /* OPERA_SMALL_VERSION */
 
 X509 *X509_STORE_CTX_get0_current_issuer(X509_STORE_CTX *ctx)
 	{
@@ -1945,7 +2089,7 @@
 	/* If we have a purpose then check it is valid */
 	if (purpose)
 		{
-		X509_PURPOSE *ptmp;
+		const X509_PURPOSE *ptmp;
 		idx = X509_PURPOSE_get_by_id(purpose);
 		if (idx == -1)
 			{
@@ -1993,7 +2137,7 @@
 		X509err(X509_F_X509_STORE_CTX_NEW,ERR_R_MALLOC_FAILURE);
 		return NULL;
 		}
-	memset(ctx, 0, sizeof(X509_STORE_CTX));
+	op_memset(ctx, 0, sizeof(X509_STORE_CTX));
 	return ctx;
 }
 
@@ -2113,13 +2257,15 @@
 	else
 		ctx->lookup_crls = X509_STORE_get1_crls;
 
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
 	ctx->check_policy = check_policy;
+#endif
 
 
-	/* This memset() can't make any sense anyway, so it's removed. As
+	/* This op_memset() can't make any sense anyway, so it's removed. As
 	 * X509_STORE_CTX_cleanup does a proper "free" on the ex_data, we put a
 	 * corresponding "new" here and remove this bogus initialisation. */
-	/* memset(&(ctx->ex_data),0,sizeof(CRYPTO_EX_DATA)); */
+	/* op_memset(&(ctx->ex_data),0,sizeof(CRYPTO_EX_DATA)); */
 	if(!CRYPTO_new_ex_data(CRYPTO_EX_INDEX_X509_STORE_CTX, ctx,
 				&(ctx->ex_data)))
 		{
@@ -2134,11 +2280,13 @@
  * This avoids X509_STORE nastiness where it isn't needed.
  */
 
+#ifndef OPERA_SMALL_VERSION
 void X509_STORE_CTX_trusted_stack(X509_STORE_CTX *ctx, STACK_OF(X509) *sk)
 {
 	ctx->other_ctx = sk;
 	ctx->get_issuer = get_issuer_sk;
 }
+#endif
 
 void X509_STORE_CTX_cleanup(X509_STORE_CTX *ctx)
 	{
@@ -2149,18 +2297,20 @@
 			X509_VERIFY_PARAM_free(ctx->param);
 		ctx->param=NULL;
 		}
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
 	if (ctx->tree != NULL)
 		{
 		X509_policy_tree_free(ctx->tree);
 		ctx->tree=NULL;
 		}
+#endif
 	if (ctx->chain != NULL)
 		{
 		sk_X509_pop_free(ctx->chain,X509_free);
 		ctx->chain=NULL;
 		}
 	CRYPTO_free_ex_data(CRYPTO_EX_INDEX_X509_STORE_CTX, ctx, &(ctx->ex_data));
-	memset(&ctx->ex_data,0,sizeof(CRYPTO_EX_DATA));
+	op_memset(&ctx->ex_data,0,sizeof(CRYPTO_EX_DATA));
 	}
 
 void X509_STORE_CTX_set_depth(X509_STORE_CTX *ctx, int depth)
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509_vfy.h openssl-1.0.0q/crypto/x509/x509_vfy.h
--- openssl-1.0.0q.orig/crypto/x509/x509_vfy.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509_vfy.h	2017-04-25 16:23:40.713620303 +0200
@@ -165,7 +165,7 @@
 
 typedef struct X509_VERIFY_PARAM_st
 	{
-	char *name;
+	const char *name;
 	time_t check_time;	/* Time to use */
 	unsigned long inh_flags; /* Inheritance flags */
 	unsigned long flags;	/* Various verify flags */
@@ -225,7 +225,7 @@
 	} /* X509_LOOKUP */;
 
 /* This is a used when verifying cert chains.  Since the
- * gathering of the cert chain can take some time (and have to be
+ * gathering of the cert chain can take some op_time (and have to be
  * 'retried', this needs to be kept and passed around. */
 struct x509_store_ctx_st      /* X509_STORE_CTX */
 	{
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509_vpm.c openssl-1.0.0q/crypto/x509/x509_vpm.c
--- openssl-1.0.0q.orig/crypto/x509/x509_vpm.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509_vpm.c	2017-04-25 16:23:40.714622386 +0200
@@ -56,14 +56,17 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include <openssl/crypto.h>
 #include <openssl/lhash.h>
 #include <openssl/buffer.h>
 #include <openssl/x509.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* X509_VERIFY_PARAM functions */
 
@@ -88,10 +91,10 @@
 X509_VERIFY_PARAM *X509_VERIFY_PARAM_new(void)
 	{
 	X509_VERIFY_PARAM *param;
-	param = OPENSSL_malloc(sizeof(X509_VERIFY_PARAM));
+	param = (X509_VERIFY_PARAM *) OPENSSL_malloc(sizeof(X509_VERIFY_PARAM));
 	if (!param)
 		return NULL;
-	memset(param, 0, sizeof(X509_VERIFY_PARAM));
+	op_memset(param, 0, sizeof(X509_VERIFY_PARAM));
 	x509_verify_param_zero(param);
 	return param;
 	}
@@ -189,11 +192,13 @@
 
 	dest->flags |= src->flags;
 
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
 	if (test_x509_verify_param_copy(policies, NULL))
 		{
 		if (!X509_VERIFY_PARAM_set1_policies(dest, src->policies))
 			return 0;
 		}
+#endif
 
 	return 1;
 	}
@@ -212,7 +217,7 @@
 int X509_VERIFY_PARAM_set1_name(X509_VERIFY_PARAM *param, const char *name)
 	{
 	if (param->name)
-		OPENSSL_free(param->name);
+		OPENSSL_free((void*)param->name);
 	param->name = BUF_strdup(name);
 	if (param->name)
 		return 1;
@@ -243,10 +248,12 @@
 	return X509_PURPOSE_set(&param->purpose, purpose);
 	}
 
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 int X509_VERIFY_PARAM_set_trust(X509_VERIFY_PARAM *param, int trust)
 	{
 	return X509_TRUST_set(&param->trust, trust);
 	}
+#endif
 
 void X509_VERIFY_PARAM_set_depth(X509_VERIFY_PARAM *param, int depth)
 	{
@@ -259,6 +266,7 @@
 	param->flags |= X509_V_FLAG_USE_CHECK_TIME;
 	}
 
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_VERIFY_PARAM
 int X509_VERIFY_PARAM_add0_policy(X509_VERIFY_PARAM *param, ASN1_OBJECT *policy)
 	{
 	if (!param->policies)
@@ -271,7 +279,9 @@
 		return 0;
 	return 1;
 	}
+#endif /* OPERA_SMALL_VERSION */
 
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
 int X509_VERIFY_PARAM_set1_policies(X509_VERIFY_PARAM *param, 
 					STACK_OF(ASN1_OBJECT) *policies)
 	{
@@ -307,6 +317,7 @@
 	param->flags |= X509_V_FLAG_POLICY_CHECK;
 	return 1;
 	}
+#endif
 
 int X509_VERIFY_PARAM_get_depth(const X509_VERIFY_PARAM *param)
 	{
@@ -319,8 +330,19 @@
  * will be searched using OBJ_search.
  */
 
-static const X509_VERIFY_PARAM default_table[] = {
-	{
+#define X509_VERIFY_PARAM_ENTRY(nam, ch_time, inh_flg, flg, purp, trst, dpth, pol) \
+	CONST_ENTRY_START(name,nam)\
+	CONST_ENTRY_SINGLE(check_time,ch_time)\
+	CONST_ENTRY_SINGLE(inh_flags,inh_flg)\
+	CONST_ENTRY_SINGLE(flags,flg)\
+	CONST_ENTRY_SINGLE(purpose,purp)\
+	CONST_ENTRY_SINGLE(trust,trst)\
+	CONST_ENTRY_SINGLE(depth,dpth)\
+	CONST_ENTRY_SINGLE(policies,pol)\
+	CONST_ENTRY_END
+
+OPENSSL_PREFIX_CONST_ARRAY(static, X509_VERIFY_PARAM, default_table, libopeay)
+	X509_VERIFY_PARAM_ENTRY(
 	"default",	/* X509 default parameters */
 	0,		/* Check time */
 	0,		/* internal flags */
@@ -329,8 +351,9 @@
 	0,		/* trust */
 	100,		/* depth */
 	NULL		/* policies */
-	},
-	{
+	)
+#ifdef SMIME_SUPPORT
+	X509_VERIFY_PARAM_ENTRY(
 	"pkcs7",			/* S/MIME sign parameters */
 	0,				/* Check time */
 	0,				/* internal flags */
@@ -339,8 +362,8 @@
 	X509_TRUST_EMAIL,		/* trust */
 	-1,				/* depth */
 	NULL				/* policies */
-	},
-	{
+	)
+	X509_VERIFY_PARAM_ENTRY(
 	"smime_sign",			/* S/MIME sign parameters */
 	0,				/* Check time */
 	0,				/* internal flags */
@@ -349,8 +372,9 @@
 	X509_TRUST_EMAIL,		/* trust */
 	-1,				/* depth */
 	NULL				/* policies */
-	},
-	{
+	)
+#endif
+	X509_VERIFY_PARAM_ENTRY(
 	"ssl_client",			/* SSL/TLS client parameters */
 	0,				/* Check time */
 	0,				/* internal flags */
@@ -359,8 +383,9 @@
 	X509_TRUST_SSL_CLIENT,		/* trust */
 	-1,				/* depth */
 	NULL				/* policies */
-	},
-	{
+	)
+#ifndef OPERA_SMALL_VERSION
+	X509_VERIFY_PARAM_ENTRY(
 	"ssl_server",			/* SSL/TLS server parameters */
 	0,				/* Check time */
 	0,				/* internal flags */
@@ -369,9 +394,13 @@
 	X509_TRUST_SSL_SERVER,		/* trust */
 	-1,				/* depth */
 	NULL				/* policies */
-	}};
+	)
+#endif /* OPERA_SMALL_VERSION */
+CONST_END(default_table)
 
+#ifndef OPERA_SMALL_VERSION
 static STACK_OF(X509_VERIFY_PARAM) *param_table = NULL;
+#endif /* OPERA_SMALL_VERSION */
 
 static int table_cmp(const X509_VERIFY_PARAM *a, const X509_VERIFY_PARAM *b)
 
@@ -384,6 +413,7 @@
 IMPLEMENT_OBJ_BSEARCH_CMP_FN(X509_VERIFY_PARAM, X509_VERIFY_PARAM,
 			     table);
 
+#ifndef OPERA_SMALL_VERSION
 static int param_cmp(const X509_VERIFY_PARAM * const *a,
 			const X509_VERIFY_PARAM * const *b)
 	{
@@ -414,23 +444,31 @@
 		return 0;
 	return 1;
 	}
+#endif /* OPERA_SMALL_VERSION */
 
 const X509_VERIFY_PARAM *X509_VERIFY_PARAM_lookup(const char *name)
 	{
+#ifndef OPERA_SMALL_VERSION
 	int idx;
+#endif /* OPERA_SMALL_VERSION */
+
 	X509_VERIFY_PARAM pm;
 
 	pm.name = (char *)name;
+#ifndef OPERA_SMALL_VERSION
 	if (param_table)
 		{
 		idx = sk_X509_VERIFY_PARAM_find(param_table, &pm);
 		if (idx != -1)
 			return sk_X509_VERIFY_PARAM_value(param_table, idx);
 		}
-	return OBJ_bsearch_table(&pm, default_table,
-			   sizeof(default_table)/sizeof(X509_VERIFY_PARAM));
+#endif /* OPERA_SMALL_VERSION */
+
+	return OBJ_bsearch_table(&pm, OPENSSL_GLOBAL_ARRAY_NAME(default_table),
+			OPENSSL_CONST_ARRAY_SIZE(default_table));
 	}
 
+#ifndef OPERA_SMALL_VERSION
 void X509_VERIFY_PARAM_table_cleanup(void)
 	{
 	if (param_table)
@@ -438,3 +476,4 @@
 						X509_VERIFY_PARAM_free);
 	param_table = NULL;
 	}
+#endif /* OPERA_SMALL_VERSION */
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509cset.c openssl-1.0.0q/crypto/x509/x509cset.c
--- openssl-1.0.0q.orig/crypto/x509/x509cset.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509cset.c	2017-04-25 16:23:40.715621396 +0200
@@ -56,7 +56,9 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/asn1.h>
 #include <openssl/objects.h>
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509name.c openssl-1.0.0q/crypto/x509/x509name.c
--- openssl-1.0.0q.orig/crypto/x509/x509name.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509name.c	2017-04-25 16:23:40.839798630 +0200
@@ -56,14 +56,17 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/stack.h>
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 #include <openssl/objects.h>
 #include <openssl/evp.h>
 #include <openssl/x509.h>
 
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 int X509_NAME_get_text_by_NID(X509_NAME *name, int nid, char *buf, int len)
 	{
 	ASN1_OBJECT *obj;
@@ -84,10 +87,11 @@
 	data=X509_NAME_ENTRY_get_data(X509_NAME_get_entry(name,i));
 	i=(data->length > (len-1))?(len-1):data->length;
 	if (buf == NULL) return(data->length);
-	memcpy(buf,data->data,i);
+	op_memcpy(buf,data->data,i);
 	buf[i]='\0';
 	return(i);
 	}
+#endif
 
 int X509_NAME_entry_count(X509_NAME *name)
 	{
@@ -135,6 +139,7 @@
 		return(sk_X509_NAME_ENTRY_value(name->entries,loc));
 	}
 
+#ifndef OPERA_SMALL_VERSION
 X509_NAME_ENTRY *X509_NAME_delete_entry(X509_NAME *name, int loc)
 	{
 	X509_NAME_ENTRY *ret;
@@ -194,6 +199,7 @@
 	X509_NAME_ENTRY_free(ne);
 	return ret;
 }
+#endif
 
 int X509_NAME_add_entry_by_txt(X509_NAME *name, const char *field, int type,
 			const unsigned char *bytes, int len, int loc, int set)
@@ -291,6 +297,7 @@
 	return nentry;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 X509_NAME_ENTRY *X509_NAME_ENTRY_create_by_NID(X509_NAME_ENTRY **ne, int nid,
 	     int type, unsigned char *bytes, int len)
 	{
@@ -307,6 +314,7 @@
 	ASN1_OBJECT_free(obj);
 	return nentry;
 	}
+#endif /* OPERA_SMALL_VERSION */
 
 X509_NAME_ENTRY *X509_NAME_ENTRY_create_by_OBJ(X509_NAME_ENTRY **ne,
 	     ASN1_OBJECT *obj, int type, const unsigned char *bytes, int len)
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509rset.c openssl-1.0.0q/crypto/x509/x509rset.c
--- openssl-1.0.0q.orig/crypto/x509/x509rset.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509rset.c	2017-04-25 16:23:40.840798757 +0200
@@ -56,13 +56,16 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/asn1.h>
 #include <openssl/objects.h>
 #include <openssl/evp.h>
 #include <openssl/x509.h>
 
+#ifndef OPERA_SMALL_VERSION
 int X509_REQ_set_version(X509_REQ *x, long version)
 	{
 	if (x == NULL) return(0);
@@ -80,4 +83,5 @@
 	if ((x == NULL) || (x->req_info == NULL)) return(0);
 	return(X509_PUBKEY_set(&x->req_info->pubkey,pkey));
 	}
+#endif
 
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509spki.c openssl-1.0.0q/crypto/x509/x509spki.c
--- openssl-1.0.0q.orig/crypto/x509/x509spki.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509spki.c	2017-04-25 16:23:40.841799723 +0200
@@ -56,10 +56,13 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/x509.h>
 
+#ifndef OPERA_SMALL_VERSION
 int NETSCAPE_SPKI_set_pubkey(NETSCAPE_SPKI *x, EVP_PKEY *pkey)
 {
 	if ((x == NULL) || (x->spkac == NULL)) return(0);
@@ -81,7 +84,7 @@
 	const unsigned char *p;
 	int spki_len;
 	NETSCAPE_SPKI *spki;
-	if(len <= 0) len = strlen(str);
+	if(len <= 0) len = op_strlen(str);
 	if (!(spki_der = OPENSSL_malloc(len + 1))) {
 		X509err(X509_F_NETSCAPE_SPKI_B64_DECODE, ERR_R_MALLOC_FAILURE);
 		return NULL;
@@ -119,3 +122,4 @@
 	OPENSSL_free(der_spki);
 	return b64_str;
 }
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/x509/x509type.c openssl-1.0.0q/crypto/x509/x509type.c
--- openssl-1.0.0q.orig/crypto/x509/x509type.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x509type.c	2017-04-25 16:23:40.842798174 +0200
@@ -56,12 +56,15 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/evp.h>
 #include <openssl/objects.h>
 #include <openssl/x509.h>
 
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 int X509_certificate_type(X509 *x, EVP_PKEY *pkey)
 	{
 	EVP_PKEY *pk;
@@ -123,3 +126,4 @@
 	return(ret);
 	}
 
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/x509/x_all.c openssl-1.0.0q/crypto/x509/x_all.c
--- openssl-1.0.0q.orig/crypto/x509/x_all.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/x509/x_all.c	2017-04-25 16:23:40.843798859 +0200
@@ -56,9 +56,12 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/stack.h>
-#include "cryptlib.h"
 #include <openssl/buffer.h>
 #include <openssl/asn1.h>
 #include <openssl/evp.h>
@@ -69,6 +72,7 @@
 #ifndef OPENSSL_NO_DSA
 #include <openssl/dsa.h>
 #endif
+#include "modules/libopeay/libopeay_arrays.h"
 
 int X509_verify(X509 *a, EVP_PKEY *r)
 	{
@@ -78,12 +82,15 @@
 		a->signature,a->cert_info,r));
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int X509_REQ_verify(X509_REQ *a, EVP_PKEY *r)
 	{
 	return( ASN1_item_verify(ASN1_ITEM_rptr(X509_REQ_INFO),
 		a->sig_alg,a->signature,a->req_info,r));
 	}
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 int NETSCAPE_SPKI_verify(NETSCAPE_SPKI *a, EVP_PKEY *r)
 	{
 	return(ASN1_item_verify(ASN1_ITEM_rptr(NETSCAPE_SPKAC),
@@ -96,26 +103,34 @@
 	return(ASN1_item_sign(ASN1_ITEM_rptr(X509_CINF), x->cert_info->signature,
 		x->sig_alg, x->signature, x->cert_info,pkey,md));
 	}
+#endif
 
+#ifdef LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
 int X509_REQ_sign(X509_REQ *x, EVP_PKEY *pkey, const EVP_MD *md)
 	{
 	return(ASN1_item_sign(ASN1_ITEM_rptr(X509_REQ_INFO),x->sig_alg, NULL,
 		x->signature, x->req_info,pkey,md));
 	}
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 int X509_CRL_sign(X509_CRL *x, EVP_PKEY *pkey, const EVP_MD *md)
 	{
 	x->crl->enc.modified = 1;
 	return(ASN1_item_sign(ASN1_ITEM_rptr(X509_CRL_INFO),x->crl->sig_alg,
 		x->sig_alg, x->signature, x->crl,pkey,md));
 	}
+#endif
 
+#ifdef LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
 int NETSCAPE_SPKI_sign(NETSCAPE_SPKI *x, EVP_PKEY *pkey, const EVP_MD *md)
 	{
 	return(ASN1_item_sign(ASN1_ITEM_rptr(NETSCAPE_SPKAC), x->sig_algor,NULL,
 		x->signature, x->spkac,pkey,md));
 	}
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 #ifndef OPENSSL_NO_FP_API
 X509 *d2i_X509_fp(FILE *fp, X509 **x509)
 	{
@@ -295,6 +310,7 @@
 	return ASN1_i2d_fp_of(DSA,i2d_DSA_PUBKEY,fp,dsa);
 	}
 #endif
+#endif /* OPERA_SMALL_VERSION */
 
 DSA *d2i_DSAPrivateKey_bio(BIO *bp, DSA **dsa)
 	{
@@ -384,18 +400,23 @@
 	return(ASN1_item_digest(ASN1_ITEM_rptr(X509_CRL),type,(char *)data,md,len));
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int X509_REQ_digest(const X509_REQ *data, const EVP_MD *type, unsigned char *md,
 	     unsigned int *len)
 	{
 	return(ASN1_item_digest(ASN1_ITEM_rptr(X509_REQ),type,(char *)data,md,len));
 	}
+#endif /* OPERA_SMALL_VERSION */
 
+#if !defined OPERA_SMALL_VERSION || !defined OPENSSL_NO_OCSP
 int X509_NAME_digest(const X509_NAME *data, const EVP_MD *type, unsigned char *md,
 	     unsigned int *len)
 	{
 	return(ASN1_item_digest(ASN1_ITEM_rptr(X509_NAME),type,(char *)data,md,len));
 	}
+#endif /* OPERA_SMALL_VERSION */
 
+#ifndef OPERA_SMALL_VERSION
 int PKCS7_ISSUER_AND_SERIAL_digest(PKCS7_ISSUER_AND_SERIAL *data, const EVP_MD *type,
 	     unsigned char *md, unsigned int *len)
 	{
@@ -516,3 +537,4 @@
 	{
 	return ASN1_d2i_bio_of(EVP_PKEY,EVP_PKEY_new,d2i_PUBKEY,bp,a);
 	}
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/.gitignore openssl-1.0.0q/crypto/x509v3/.gitignore
--- openssl-1.0.0q.orig/crypto/x509v3/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/.gitignore	2017-04-25 16:23:40.844798149 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/ext_dat.h openssl-1.0.0q/crypto/x509v3/ext_dat.h
--- openssl-1.0.0q.orig/crypto/x509v3/ext_dat.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/ext_dat.h	2017-04-25 16:23:40.845798276 +0200
@@ -57,76 +57,84 @@
  */
 /* This file contains a table of "standard" extensions */
 
-extern X509V3_EXT_METHOD v3_bcons, v3_nscert, v3_key_usage, v3_ext_ku;
-extern X509V3_EXT_METHOD v3_pkey_usage_period, v3_sxnet, v3_info, v3_sinfo;
-extern X509V3_EXT_METHOD v3_ns_ia5_list[], v3_alt[], v3_skey_id, v3_akey_id;
-extern X509V3_EXT_METHOD v3_crl_num, v3_crl_reason, v3_crl_invdate;
-extern X509V3_EXT_METHOD v3_delta_crl, v3_cpols, v3_crld, v3_freshest_crl;
-extern X509V3_EXT_METHOD v3_ocsp_nonce, v3_ocsp_accresp, v3_ocsp_acutoff;
-extern X509V3_EXT_METHOD v3_ocsp_crlid, v3_ocsp_nocheck, v3_ocsp_serviceloc;
-extern X509V3_EXT_METHOD v3_crl_hold, v3_pci;
-extern X509V3_EXT_METHOD v3_policy_mappings, v3_policy_constraints;
-extern X509V3_EXT_METHOD v3_name_constraints, v3_inhibit_anyp, v3_idp;
-extern X509V3_EXT_METHOD v3_addr, v3_asid;
+#include "modules/libopeay/libopeay_arrays.h"
+
+#ifdef HAS_COMPLEX_GLOBALS
+extern const X509V3_EXT_METHOD g_v3_bcons, g_v3_nscert, g_v3_key_usage, g_v3_ext_ku;
+extern const X509V3_EXT_METHOD g_v3_pkey_usage_period, g_v3_sxnet, g_v3_info, g_v3_sinfo;
+extern const X509V3_EXT_METHOD g_v3_ns_ia5_list[], g_v3_alt[], g_v3_skey_id, g_v3_akey_id;
+extern const X509V3_EXT_METHOD g_v3_crl_num, g_v3_crl_reason, g_v3_crl_invdate;
+extern const X509V3_EXT_METHOD g_v3_delta_crl, g_v3_cpols, g_v3_crld;
+extern const X509V3_EXT_METHOD g_v3_ocsp_nonce, g_v3_ocsp_accresp, g_v3_ocsp_acutoff;
+extern const X509V3_EXT_METHOD g_v3_ocsp_crlid, g_v3_ocsp_nocheck, g_v3_ocsp_serviceloc;
+extern const X509V3_EXT_METHOD g_v3_crl_hold, g_v3_pci;
+extern const X509V3_EXT_METHOD g_v3_policy_mappings, g_v3_policy_constraints;
+extern const X509V3_EXT_METHOD g_v3_name_constraints, g_v3_inhibit_anyp;
+#ifndef OPENSSL_NO_RFC3779
+extern const X509V3_EXT_METHOD g_v3_addr, g_v3_asid;
+#endif
+#endif
 
 /* This table will be searched using OBJ_bsearch so it *must* kept in
  * order of the ext_nid values.
  */
 
-static const X509V3_EXT_METHOD *standard_exts[] = {
-&v3_nscert,
-&v3_ns_ia5_list[0],
-&v3_ns_ia5_list[1],
-&v3_ns_ia5_list[2],
-&v3_ns_ia5_list[3],
-&v3_ns_ia5_list[4],
-&v3_ns_ia5_list[5],
-&v3_ns_ia5_list[6],
-&v3_skey_id,
-&v3_key_usage,
-&v3_pkey_usage_period,
-&v3_alt[0],
-&v3_alt[1],
-&v3_bcons,
-&v3_crl_num,
-&v3_cpols,
-&v3_akey_id,
-&v3_crld,
-&v3_ext_ku,
-&v3_delta_crl,
-&v3_crl_reason,
+#define OPERA_V3_METHOD_ENTRY(x) CONST_ENTRY(&OPENSSL_GLOBAL_ITEM_NAME(x) )
+#define OPERA_V3_METHOD_ARRAY_ENTRY(x,i) CONST_ENTRY(&OPENSSL_GLOBAL_ARRAY_NAME(x)[i])
+
+typedef const X509V3_EXT_METHOD *X509V3_EXT_METHOD_pointer;
+
+OPENSSL_PREFIX_CONST_ARRAY(static, X509V3_EXT_METHOD_pointer , ext_dat__standard_exts, libopeay)
+OPERA_V3_METHOD_ENTRY(v3_nscert)
+OPERA_V3_METHOD_ARRAY_ENTRY(v3_ns_ia5_list,0)
+OPERA_V3_METHOD_ARRAY_ENTRY(v3_ns_ia5_list,1)
+OPERA_V3_METHOD_ARRAY_ENTRY(v3_ns_ia5_list,2)
+OPERA_V3_METHOD_ARRAY_ENTRY(v3_ns_ia5_list,3)
+OPERA_V3_METHOD_ARRAY_ENTRY(v3_ns_ia5_list,4)
+OPERA_V3_METHOD_ARRAY_ENTRY(v3_ns_ia5_list,5)
+OPERA_V3_METHOD_ARRAY_ENTRY(v3_ns_ia5_list,6)
+OPERA_V3_METHOD_ENTRY(v3_skey_id)
+OPERA_V3_METHOD_ENTRY(v3_key_usage)
+OPERA_V3_METHOD_ENTRY(v3_pkey_usage_period)
+OPERA_V3_METHOD_ARRAY_ENTRY(v3_alt,0)
+OPERA_V3_METHOD_ARRAY_ENTRY(v3_alt,1)
+OPERA_V3_METHOD_ENTRY(v3_bcons)
+OPERA_V3_METHOD_ENTRY(v3_crl_num)
+OPERA_V3_METHOD_ENTRY(v3_cpols)
+OPERA_V3_METHOD_ENTRY(v3_akey_id)
+OPERA_V3_METHOD_ENTRY(v3_crld)
+OPERA_V3_METHOD_ENTRY(v3_ext_ku)
+OPERA_V3_METHOD_ENTRY(v3_delta_crl)
+OPERA_V3_METHOD_ENTRY(v3_crl_reason)
 #ifndef OPENSSL_NO_OCSP
-&v3_crl_invdate,
+OPERA_V3_METHOD_ENTRY(v3_crl_invdate)
 #endif
-&v3_sxnet,
-&v3_info,
+OPERA_V3_METHOD_ENTRY(v3_sxnet)
+OPERA_V3_METHOD_ENTRY(v3_info)
 #ifndef OPENSSL_NO_RFC3779
-&v3_addr,
-&v3_asid,
+OPERA_V3_METHOD_ENTRY(v3_addr)
+OPERA_V3_METHOD_ENTRY(v3_asid)
 #endif
 #ifndef OPENSSL_NO_OCSP
-&v3_ocsp_nonce,
-&v3_ocsp_crlid,
-&v3_ocsp_accresp,
-&v3_ocsp_nocheck,
-&v3_ocsp_acutoff,
-&v3_ocsp_serviceloc,
+OPERA_V3_METHOD_ENTRY(v3_ocsp_nonce)
+OPERA_V3_METHOD_ENTRY(v3_ocsp_crlid)
+OPERA_V3_METHOD_ENTRY(v3_ocsp_accresp)
+OPERA_V3_METHOD_ENTRY(v3_ocsp_nocheck)
+OPERA_V3_METHOD_ENTRY(v3_ocsp_acutoff)
+OPERA_V3_METHOD_ENTRY(v3_ocsp_serviceloc)
 #endif
-&v3_sinfo,
-&v3_policy_constraints,
+OPERA_V3_METHOD_ENTRY(v3_sinfo)
+OPERA_V3_METHOD_ENTRY(v3_policy_constraints)
 #ifndef OPENSSL_NO_OCSP
-&v3_crl_hold,
+OPERA_V3_METHOD_ENTRY(v3_crl_hold)
 #endif
-&v3_pci,
-&v3_name_constraints,
-&v3_policy_mappings,
-&v3_inhibit_anyp,
-&v3_idp,
-&v3_alt[2],
-&v3_freshest_crl,
-};
+OPERA_V3_METHOD_ENTRY(v3_pci)
+OPERA_V3_METHOD_ENTRY(v3_policy_mappings)
+OPERA_V3_METHOD_ENTRY(v3_name_constraints)
+OPERA_V3_METHOD_ENTRY(v3_inhibit_anyp)
+CONST_END(ext_dat__standard_exts)
+#define standard_exts OPENSSL_GLOBAL_ARRAY_NAME(ext_dat__standard_exts)
 
 /* Number of standard extensions */
 
-#define STANDARD_EXTENSION_COUNT (sizeof(standard_exts)/sizeof(X509V3_EXT_METHOD *))
-
+#define STANDARD_EXTENSION_COUNT  OPENSSL_CONST_ARRAY_SIZE(ext_dat__standard_exts)
